require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&__ASM_APIC_H)) {
    eval 'sub __ASM_APIC_H () {1;}' unless defined(&__ASM_APIC_H);
    require 'linux/config.ph';
    require 'linux/pm.ph';
    require 'asm/apicdef.ph';
    require 'asm/system.ph';
    if(defined(&CONFIG_X86_LOCAL_APIC)) {
	eval 'sub APIC_DEBUG () {0;}' unless defined(&APIC_DEBUG);
	if((defined(&APIC_DEBUG) ? &APIC_DEBUG : undef)) {
	    eval 'sub Dprintk () {( &x...)  &printk( &x);}' unless defined(&Dprintk);
	} else {
	    eval 'sub Dprintk () {( &x...);}' unless defined(&Dprintk);
	}
	eval 'sub apic_write_atomic {
	    my($reg,$v) = @_;
    	    eval q({  &xchg(( &volatile my $int *)( &APIC_BASE+$reg), $v); });
	}' unless defined(&apic_write_atomic);
	eval 'sub apic_read {
	    my($reg) = @_;
    	    eval q({ *(( &volatile my $int *)( &APIC_BASE+$reg)); });
	}' unless defined(&apic_read);
	eval 'sub apic_wait_icr_idle {
	    my($void) = @_;
    	    eval q({  &while (  &apic_read(  &APIC_ICR ) &  &APIC_ICR_BUSY ); });
	}' unless defined(&apic_wait_icr_idle);
	if(defined(&CONFIG_X86_GOOD_APIC)) {
	    eval 'sub FORCE_READ_AROUND_WRITE () {0;}' unless defined(&FORCE_READ_AROUND_WRITE);
	    eval 'sub apic_read_around {
	        my($x) = @_;
    		eval q();
	    }' unless defined(&apic_read_around);
	    eval 'sub apic_write_around {
	        my($x,$y) = @_;
    		eval q( &apic_write(($x),($y)));
	    }' unless defined(&apic_write_around);
	} else {
	    eval 'sub FORCE_READ_AROUND_WRITE () {1;}' unless defined(&FORCE_READ_AROUND_WRITE);
	    eval 'sub apic_read_around {
	        my($x) = @_;
    		eval q( &apic_read($x));
	    }' unless defined(&apic_read_around);
	    eval 'sub apic_write_around {
	        my($x,$y) = @_;
    		eval q( &apic_write_atomic(($x),($y)));
	    }' unless defined(&apic_write_around);
	}
	eval 'sub ack_APIC_irq {
	    my($void) = @_;
    	    eval q({  &apic_write_around( &APIC_EOI, 0); });
	}' unless defined(&ack_APIC_irq);
	eval 'sub NMI_NONE () {0;}' unless defined(&NMI_NONE);
	eval 'sub NMI_IO_APIC () {1;}' unless defined(&NMI_IO_APIC);
	eval 'sub NMI_LOCAL_APIC () {2;}' unless defined(&NMI_LOCAL_APIC);
	eval 'sub NMI_INVALID () {3;}' unless defined(&NMI_INVALID);
    }
    eval 'sub clustered_apic_mode () {0;}' unless defined(&clustered_apic_mode);
    eval 'sub esr_disable () {0;}' unless defined(&esr_disable);
}
1;
