require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&X86_64_MSR_H)) {
    eval 'sub X86_64_MSR_H () {1;}' unless defined(&X86_64_MSR_H);
    unless(defined(&__ASSEMBLY__)) {
	eval 'sub rdmsr {
	    my($msr,$val1,$val2) = @_;
    	    eval q(\\"(assembly code)\\");
	}' unless defined(&rdmsr);
	eval 'sub rdmsrl {
	    my($msr,$val) = @_;
    	    eval q(\\"(assembly code)\\");
	}' unless defined(&rdmsrl);
	eval 'sub wrmsr {
	    my($msr,$val1,$val2) = @_;
    	    eval q(\\"(assembly code)\\");
	}' unless defined(&wrmsr);
	eval 'sub wrmsrl {
	    my($msr,$val) = @_;
    	    eval q( &wrmsr($msr,( &__u32)(( &__u64)($val)),(( &__u64)($val))>>32));
	}' unless defined(&wrmsrl);
	eval 'sub checking_wrmsrl {
	    my($msr,$val) = @_;
    	    eval q(({ \'int\'  &ret__;  &asm  &volatile(\\"2: wrmsr ; xorl %0,%0\\\\n\\" \\"1:\\\\n\\\\t\\" \\".section .fixup,\\\\\\"ax\\\\\\"\\\\n\\\\t\\" \\"3:  movl %4,%0 ; jmp 1b\\\\n\\\\t\\" \\".previous\\\\n\\\\t\\" \\".section __ex_table,\\\\\\"a\\\\\\"\\\\n\\" \\"   .align 8\\\\n\\\\t\\" \\"   .quad 	2b,3b\\\\n\\\\t\\" \\".previous\\" : \\"=a\\" ( &ret__) : \\"c\\" ($msr), \\"0\\" (( &__u32)$val), \\"d\\" (($val)>>32), \\"i\\" (- &EFAULT));  &ret__; }));
	}' unless defined(&checking_wrmsrl);
	eval 'sub rdtsc {
	    my($low,$high) = @_;
    	    eval q(\\"(assembly code)\\");
	}' unless defined(&rdtsc);
	eval 'sub rdtscl {
	    my($low) = @_;
    	    eval q(\\"(assembly code)\\");
	}' unless defined(&rdtscl);
	eval 'sub rdtscll {
	    my($val) = @_;
    	    eval q( &do { \'unsigned int a\', &d;  &asm  &volatile(\\"rdtsc\\" : \\"=a\\" , \\"=d\\" ); = | (( &d)<<32); }  &while(0));
	}' unless defined(&rdtscll);
	eval 'sub rdpmc {
	    my($counter,$low,$high) = @_;
    	    eval q(\\"(assembly code)\\");
	}' unless defined(&rdpmc);
	eval 'sub write_tsc {
	    my($val1,$val2) = @_;
    	    eval q( &wrmsr(0x10, $val1, $val2));
	}' unless defined(&write_tsc);
	eval 'sub rdpmc {
	    my($counter,$low,$high) = @_;
    	    eval q(\\"(assembly code)\\");
	}' unless defined(&rdpmc);
    }
    eval 'sub MSR_EFER () {0xc0000080;}' unless defined(&MSR_EFER);
    eval 'sub MSR_STAR () {0xc0000081;}' unless defined(&MSR_STAR);
    eval 'sub MSR_LSTAR () {0xc0000082;}' unless defined(&MSR_LSTAR);
    eval 'sub MSR_CSTAR () {0xc0000083;}' unless defined(&MSR_CSTAR);
    eval 'sub MSR_SYSCALL_MASK () {0xc0000084;}' unless defined(&MSR_SYSCALL_MASK);
    eval 'sub MSR_FS_BASE () {0xc0000100;}' unless defined(&MSR_FS_BASE);
    eval 'sub MSR_GS_BASE () {0xc0000101;}' unless defined(&MSR_GS_BASE);
    eval 'sub MSR_KERNEL_GS_BASE () {0xc0000102;}' unless defined(&MSR_KERNEL_GS_BASE);
    eval 'sub _EFER_SCE () {0;}' unless defined(&_EFER_SCE);
    eval 'sub _EFER_LME () {8;}' unless defined(&_EFER_LME);
    eval 'sub _EFER_LMA () {10;}' unless defined(&_EFER_LMA);
    eval 'sub _EFER_NX () {11;}' unless defined(&_EFER_NX);
    eval 'sub EFER_SCE () {(1<< &_EFER_SCE);}' unless defined(&EFER_SCE);
    eval 'sub EFER_LME () {(1<< &EFER_LME);}' unless defined(&EFER_LME);
    eval 'sub EFER_LMA () {(1<< &EFER_LMA);}' unless defined(&EFER_LMA);
    eval 'sub EFER_NX () {(1<< &_EFER_NX);}' unless defined(&EFER_NX);
    eval 'sub MSR_IA32_PLATFORM_ID () {0x17;}' unless defined(&MSR_IA32_PLATFORM_ID);
    eval 'sub MSR_IA32_PERFCTR0 () {0xc1;}' unless defined(&MSR_IA32_PERFCTR0);
    eval 'sub MSR_IA32_PERFCTR1 () {0xc2;}' unless defined(&MSR_IA32_PERFCTR1);
    eval 'sub MSR_IA32_BBL_CR_CTL () {0x119;}' unless defined(&MSR_IA32_BBL_CR_CTL);
    eval 'sub MSR_IA32_MCG_CAP () {0x179;}' unless defined(&MSR_IA32_MCG_CAP);
    eval 'sub MSR_IA32_MCG_STATUS () {0x17a;}' unless defined(&MSR_IA32_MCG_STATUS);
    eval 'sub MSR_IA32_MCG_CTL () {0x17b;}' unless defined(&MSR_IA32_MCG_CTL);
    eval 'sub MSR_IA32_EVNTSEL0 () {0x186;}' unless defined(&MSR_IA32_EVNTSEL0);
    eval 'sub MSR_IA32_EVNTSEL1 () {0x187;}' unless defined(&MSR_IA32_EVNTSEL1);
    eval 'sub MSR_IA32_DEBUGCTLMSR () {0x1d9;}' unless defined(&MSR_IA32_DEBUGCTLMSR);
    eval 'sub MSR_IA32_LASTBRANCHFROMIP () {0x1db;}' unless defined(&MSR_IA32_LASTBRANCHFROMIP);
    eval 'sub MSR_IA32_LASTBRANCHTOIP () {0x1dc;}' unless defined(&MSR_IA32_LASTBRANCHTOIP);
    eval 'sub MSR_IA32_LASTINTFROMIP () {0x1dd;}' unless defined(&MSR_IA32_LASTINTFROMIP);
    eval 'sub MSR_IA32_LASTINTTOIP () {0x1de;}' unless defined(&MSR_IA32_LASTINTTOIP);
    eval 'sub MSR_IA32_MC0_CTL () {0x400;}' unless defined(&MSR_IA32_MC0_CTL);
    eval 'sub MSR_IA32_MC0_STATUS () {0x401;}' unless defined(&MSR_IA32_MC0_STATUS);
    eval 'sub MSR_IA32_MC0_ADDR () {0x402;}' unless defined(&MSR_IA32_MC0_ADDR);
    eval 'sub MSR_IA32_MC0_MISC () {0x403;}' unless defined(&MSR_IA32_MC0_MISC);
    eval 'sub MSR_P6_PERFCTR0 () {0xc1;}' unless defined(&MSR_P6_PERFCTR0);
    eval 'sub MSR_P6_PERFCTR1 () {0xc2;}' unless defined(&MSR_P6_PERFCTR1);
    eval 'sub MSR_P6_EVNTSEL0 () {0x186;}' unless defined(&MSR_P6_EVNTSEL0);
    eval 'sub MSR_P6_EVNTSEL1 () {0x187;}' unless defined(&MSR_P6_EVNTSEL1);
    eval 'sub MSR_K7_EVNTSEL0 () {0xc0010000;}' unless defined(&MSR_K7_EVNTSEL0);
    eval 'sub MSR_K7_PERFCTR0 () {0xc0010004;}' unless defined(&MSR_K7_PERFCTR0);
    eval 'sub MSR_K7_EVNTSEL1 () {0xc0010001;}' unless defined(&MSR_K7_EVNTSEL1);
    eval 'sub MSR_K7_PERFCTR1 () {0xc0010005;}' unless defined(&MSR_K7_PERFCTR1);
    eval 'sub MSR_K7_EVNTSEL2 () {0xc0010002;}' unless defined(&MSR_K7_EVNTSEL2);
    eval 'sub MSR_K7_PERFCTR2 () {0xc0010006;}' unless defined(&MSR_K7_PERFCTR2);
    eval 'sub MSR_K7_EVNTSEL3 () {0xc0010003;}' unless defined(&MSR_K7_EVNTSEL3);
    eval 'sub MSR_K7_PERFCTR3 () {0xc0010007;}' unless defined(&MSR_K7_PERFCTR3);
    eval 'sub MSR_K8_TOP_MEM1 () {0xc001001a;}' unless defined(&MSR_K8_TOP_MEM1);
    eval 'sub MSR_K8_TOP_MEM2 () {0xc001001d;}' unless defined(&MSR_K8_TOP_MEM2);
    eval 'sub MSR_K8_SYSCFG () {0xc0000010;}' unless defined(&MSR_K8_SYSCFG);
    eval 'sub MSR_K6_EFER () {0xc0000080;}' unless defined(&MSR_K6_EFER);
    eval 'sub MSR_K6_STAR () {0xc0000081;}' unless defined(&MSR_K6_STAR);
    eval 'sub MSR_K6_WHCR () {0xc0000082;}' unless defined(&MSR_K6_WHCR);
    eval 'sub MSR_K6_UWCCR () {0xc0000085;}' unless defined(&MSR_K6_UWCCR);
    eval 'sub MSR_K6_PSOR () {0xc0000087;}' unless defined(&MSR_K6_PSOR);
    eval 'sub MSR_K6_PFIR () {0xc0000088;}' unless defined(&MSR_K6_PFIR);
    eval 'sub MSR_IDT_FCR1 () {0x107;}' unless defined(&MSR_IDT_FCR1);
    eval 'sub MSR_IDT_FCR2 () {0x108;}' unless defined(&MSR_IDT_FCR2);
    eval 'sub MSR_IDT_FCR3 () {0x109;}' unless defined(&MSR_IDT_FCR3);
    eval 'sub MSR_IDT_FCR4 () {0x10a;}' unless defined(&MSR_IDT_FCR4);
    eval 'sub MSR_IDT_MCR0 () {0x110;}' unless defined(&MSR_IDT_MCR0);
    eval 'sub MSR_IDT_MCR1 () {0x111;}' unless defined(&MSR_IDT_MCR1);
    eval 'sub MSR_IDT_MCR2 () {0x112;}' unless defined(&MSR_IDT_MCR2);
    eval 'sub MSR_IDT_MCR3 () {0x113;}' unless defined(&MSR_IDT_MCR3);
    eval 'sub MSR_IDT_MCR4 () {0x114;}' unless defined(&MSR_IDT_MCR4);
    eval 'sub MSR_IDT_MCR5 () {0x115;}' unless defined(&MSR_IDT_MCR5);
    eval 'sub MSR_IDT_MCR6 () {0x116;}' unless defined(&MSR_IDT_MCR6);
    eval 'sub MSR_IDT_MCR7 () {0x117;}' unless defined(&MSR_IDT_MCR7);
    eval 'sub MSR_IDT_MCR_CTRL () {0x120;}' unless defined(&MSR_IDT_MCR_CTRL);
    eval 'sub MSR_VIA_FCR () {0x1107;}' unless defined(&MSR_VIA_FCR);
    eval 'sub MSR_IA32_P5_MC_ADDR () {0;}' unless defined(&MSR_IA32_P5_MC_ADDR);
    eval 'sub MSR_IA32_P5_MC_TYPE () {1;}' unless defined(&MSR_IA32_P5_MC_TYPE);
    eval 'sub MSR_IA32_PLATFORM_ID () {0x17;}' unless defined(&MSR_IA32_PLATFORM_ID);
    eval 'sub MSR_IA32_EBL_CR_POWERON () {0x2a;}' unless defined(&MSR_IA32_EBL_CR_POWERON);
    eval 'sub MSR_IA32_APICBASE () {0x1b;}' unless defined(&MSR_IA32_APICBASE);
    eval 'sub MSR_IA32_APICBASE_BSP () {(1<<8);}' unless defined(&MSR_IA32_APICBASE_BSP);
    eval 'sub MSR_IA32_APICBASE_ENABLE () {(1<<11);}' unless defined(&MSR_IA32_APICBASE_ENABLE);
    eval 'sub MSR_IA32_APICBASE_BASE () {(0xfffff<<12);}' unless defined(&MSR_IA32_APICBASE_BASE);
}
1;
