require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&ZUTIL_H)) {
    eval 'sub ZUTIL_H () {1;}' unless defined(&ZUTIL_H);
    eval 'sub ZLIB_INTERNAL () {1;}' unless defined(&ZLIB_INTERNAL);
    require 'zlib.ph';
    if(defined(&STDC)) {
	require 'stddef.ph';
	require 'string.ph';
	require 'stdlib.ph';
    }
    if(defined(&NO_ERRNO_H)) {
    } else {
	require 'errno.ph';
    }
    unless(defined(&local)) {
	eval 'sub local () { &static;}' unless defined(&local);
    }
    eval 'sub ERR_MSG {
        my($err) = @_;
	    eval q( $z_errmsg[ &Z_NEED_DICT-($err)]);
    }' unless defined(&ERR_MSG);
    eval 'sub ERR_RETURN {
        my($strm,$err) = @_;
	    eval q( &return ( ($strm->{msg}) =  &ERR_MSG($err), ($err)));
    }' unless defined(&ERR_RETURN);
    unless(defined(&DEF_WBITS)) {
	eval 'sub DEF_WBITS () { &MAX_WBITS;}' unless defined(&DEF_WBITS);
    }
    if((defined(&MAX_MEM_LEVEL) ? &MAX_MEM_LEVEL : undef) >= 8) {
	eval 'sub DEF_MEM_LEVEL () {8;}' unless defined(&DEF_MEM_LEVEL);
    } else {
	eval 'sub DEF_MEM_LEVEL () { &MAX_MEM_LEVEL;}' unless defined(&DEF_MEM_LEVEL);
    }
    eval 'sub STORED_BLOCK () {0;}' unless defined(&STORED_BLOCK);
    eval 'sub STATIC_TREES () {1;}' unless defined(&STATIC_TREES);
    eval 'sub DYN_TREES () {2;}' unless defined(&DYN_TREES);
    eval 'sub MIN_MATCH () {3;}' unless defined(&MIN_MATCH);
    eval 'sub MAX_MATCH () {258;}' unless defined(&MAX_MATCH);
    eval 'sub PRESET_DICT () {0x20;}' unless defined(&PRESET_DICT);
    if(defined( &MSDOS) || (defined( &WINDOWS)  && !defined( &WIN32))) {
	eval 'sub OS_CODE () {0x;}' unless defined(&OS_CODE);
	if(defined( &__TURBOC__) || defined( &__BORLANDC__)) {
	} else {
	    require 'alloc.ph';
	}
    } else {
	require 'malloc.ph';
    }
}
if(defined(&AMIGA)) {
    eval 'sub OS_CODE () {0x1;}' unless defined(&OS_CODE);
}
if(defined( &VAXC) || defined( &VMS)) {
    eval 'sub OS_CODE () {0x2;}' unless defined(&OS_CODE);
    eval 'sub F_OPEN {
        my($name, $mode) = @_;
	    eval q( &fopen(($name), ($mode), \\"mbc=60\\", \\"ctx=stm\\", \\"rfm=fix\\", \\"mrs=512\\"));
    }' unless defined(&F_OPEN);
}
if(defined( &ATARI) || defined( &atarist)) {
    eval 'sub OS_CODE () {0x5;}' unless defined(&OS_CODE);
}
if(defined(&OS2)) {
    eval 'sub OS_CODE () {0x6;}' unless defined(&OS_CODE);
}
if(defined( &MACOS) || defined( &TARGET_OS_MAC)) {
    eval 'sub OS_CODE () {0x7;}' unless defined(&OS_CODE);
    if(defined( &__MWERKS__)  && (defined(&__dest_os) ? &__dest_os : undef) != (defined(&__be_os) ? &__be_os : undef)  && (defined(&__dest_os) ? &__dest_os : undef) != (defined(&__win32_os) ? &__win32_os : undef)) {
	require 'unix.ph';
    } else {
	unless(defined(&fdopen)) {
	    eval 'sub fdopen {
	        my($fd,$mode) = @_;
    		eval q( &NULL);
	    }' unless defined(&fdopen);
	}
    }
}
if(defined(&TOPS20)) {
    eval 'sub OS_CODE () {0xa;}' unless defined(&OS_CODE);
}
if(defined(&WIN32)) {
    unless(defined(&__CYGWIN__)) {
	eval 'sub OS_CODE () {0xb;}' unless defined(&OS_CODE);
    }
}
if(defined(&__50SERIES)) {
    eval 'sub OS_CODE () {0xf;}' unless defined(&OS_CODE);
}
if(defined( &_BEOS_) || defined( &RISCOS)) {
    eval 'sub fdopen {
        my($fd,$mode) = @_;
	    eval q( &NULL);
    }' unless defined(&fdopen);
}
if((defined( &_MSC_VER)  && ((defined(&_MSC_VER) ? &_MSC_VER : undef) > 600))) {
    if(defined( &_WIN32_WCE)) {
	eval 'sub fdopen {
	    my($fd,$mode) = @_;
    	    eval q( &NULL);
	}' unless defined(&fdopen);
	unless(defined(&_PTRDIFF_T_DEFINED)) {
	    eval 'sub _PTRDIFF_T_DEFINED () {1;}' unless defined(&_PTRDIFF_T_DEFINED);
	}
    } else {
	eval 'sub fdopen {
	    my($fd,$type) = @_;
    	    eval q( &_fdopen($fd,$type));
	}' unless defined(&fdopen);
    }
}
unless(defined(&OS_CODE)) {
    eval 'sub OS_CODE () {0x3;}' unless defined(&OS_CODE);
}
unless(defined(&F_OPEN)) {
    eval 'sub F_OPEN {
        my($name, $mode) = @_;
	    eval q( &fopen(($name), ($mode)));
    }' unless defined(&F_OPEN);
}
if(defined( &STDC99) || (defined( &__TURBOC__)  && (defined(&__TURBOC__) ? &__TURBOC__ : undef) >= 0x550)) {
    unless(defined(&HAVE_VSNPRINTF)) {
	eval 'sub HAVE_VSNPRINTF () {1;}' unless defined(&HAVE_VSNPRINTF);
    }
}
if(defined( &__CYGWIN__)) {
    unless(defined(&HAVE_VSNPRINTF)) {
	eval 'sub HAVE_VSNPRINTF () {1;}' unless defined(&HAVE_VSNPRINTF);
    }
}
unless(defined(&HAVE_VSNPRINTF)) {
    if(defined(&MSDOS)) {
	eval 'sub NO_vsnprintf () {1;}' unless defined(&NO_vsnprintf);
    }
    if(defined(&__TURBOC__)) {
	eval 'sub NO_vsnprintf () {1;}' unless defined(&NO_vsnprintf);
    }
    if(defined(&WIN32)) {
	if(!defined( &vsnprintf)  && !defined( &NO_vsnprintf)) {
	    eval 'sub vsnprintf () { &_vsnprintf;}' unless defined(&vsnprintf);
	}
    }
    if(defined(&__SASC)) {
	eval 'sub NO_vsnprintf () {1;}' unless defined(&NO_vsnprintf);
    }
}
if(defined(&VMS)) {
    eval 'sub NO_vsnprintf () {1;}' unless defined(&NO_vsnprintf);
}
if(defined(&HAVE_STRERROR)) {
    unless(defined(&VMS)) {
    }
    eval 'sub zstrerror {
        my($errnum) = @_;
	    eval q( &strerror($errnum));
    }' unless defined(&zstrerror);
} else {
    eval 'sub zstrerror {
        my($errnum) = @_;
	    eval q(\\"\\");
    }' unless defined(&zstrerror);
}
if(defined( &pyr)) {
    eval 'sub NO_MEMCPY () {1;}' unless defined(&NO_MEMCPY);
}
if(defined( &SMALL_MEDIUM)  && !defined( &_MSC_VER)  && !defined( &__SC__)) {
    eval 'sub NO_MEMCPY () {1;}' unless defined(&NO_MEMCPY);
}
if(defined( &STDC)  && !defined( &HAVE_MEMCPY)  && !defined( &NO_MEMCPY)) {
    eval 'sub HAVE_MEMCPY () {1;}' unless defined(&HAVE_MEMCPY);
}
if(defined(&HAVE_MEMCPY)) {
    if(defined(&SMALL_MEDIUM)) {
	eval 'sub zmemcpy () { &_fmemcpy;}' unless defined(&zmemcpy);
	eval 'sub zmemcmp () { &_fmemcmp;}' unless defined(&zmemcmp);
	eval 'sub zmemzero {
	    my($dest, $len) = @_;
    	    eval q( &_fmemset($dest, 0, $len));
	}' unless defined(&zmemzero);
    } else {
	eval 'sub zmemcpy () { &memcpy;}' unless defined(&zmemcpy);
	eval 'sub zmemcmp () { &memcmp;}' unless defined(&zmemcmp);
	eval 'sub zmemzero {
	    my($dest, $len) = @_;
    	    eval q( &memset($dest, 0, $len));
	}' unless defined(&zmemzero);
    }
} else {
}
if(defined(&DEBUG)) {
    require 'stdio.ph';
    eval 'sub Assert {
        my($cond,$msg) = @_;
	    eval q({ &if(!($cond))  &z_error($msg);});
    }' unless defined(&Assert);
    eval 'sub Trace {
        my($x) = @_;
	    eval q({ &if ( &z_verbose>=0)  &fprintf $x ;});
    }' unless defined(&Trace);
    eval 'sub Tracev {
        my($x) = @_;
	    eval q({ &if ( &z_verbose>0)  &fprintf $x ;});
    }' unless defined(&Tracev);
    eval 'sub Tracevv {
        my($x) = @_;
	    eval q({ &if ( &z_verbose>1)  &fprintf $x ;});
    }' unless defined(&Tracevv);
    eval 'sub Tracec {
        my($c,$x) = @_;
	    eval q({ &if ( &z_verbose>0 && ($c))  &fprintf $x ;});
    }' unless defined(&Tracec);
    eval 'sub Tracecv {
        my($c,$x) = @_;
	    eval q({ &if ( &z_verbose>1 && ($c))  &fprintf $x ;});
    }' unless defined(&Tracecv);
} else {
    eval 'sub Assert {
        my($cond,$msg) = @_;
	    eval q();
    }' unless defined(&Assert);
    eval 'sub Trace {
        my($x) = @_;
	    eval q();
    }' unless defined(&Trace);
    eval 'sub Tracev {
        my($x) = @_;
	    eval q();
    }' unless defined(&Tracev);
    eval 'sub Tracevv {
        my($x) = @_;
	    eval q();
    }' unless defined(&Tracevv);
    eval 'sub Tracec {
        my($c,$x) = @_;
	    eval q();
    }' unless defined(&Tracec);
    eval 'sub Tracecv {
        my($c,$x) = @_;
	    eval q();
    }' unless defined(&Tracecv);
}
unless(defined(&ZALLOC)) {
    sub ZALLOC {
	my($strm, $items, $size) = @_;
	eval q((*(($strm)-> &zalloc))(($strm)-> &opaque, ($items), ($size)));
    }
}
unless(defined(&ZFREE)) {
    sub ZFREE {
	my($strm, $addr) = @_;
	eval q((*(($strm)-> &zfree))(($strm)-> &opaque, ( &voidpf)($addr)));
    }
}
unless(defined(&TRY_FREE)) {
    sub TRY_FREE {
	my($s, $p) = @_;
	eval q({ &if ($p)  &ZFREE($s, $p);});
    }
}
    }
1;
